// Generated by CoffeeScript 1.10.0
(function() {
  var QedaPattern,
    hasProp = {}.hasOwnProperty;

  QedaPattern = (function() {
    function QedaPattern(element) {
      this.settings = element.library.pattern;
      this.shapes = [];
      this.currentLayer = ['topCopper'];
      this.currentLineWidth = 0;
      this.type = 'smd';
      this.attributes = {};
      this.pads = {};
      this.x = 0;
      this.y = 0;
    }

    QedaPattern.prototype.attribute = function(name, attribute) {
      attribute.name = name;
      this.attributes[name] = this._addShape('attribute', attribute);
      return this;
    };

    QedaPattern.prototype.circle = function(x, y, radius) {
      this._addShape('circle', {
        x: x,
        y: y,
        radius: radius
      });
      return this;
    };

    QedaPattern.prototype.layer = function(layer) {
      if (!Array.isArray(layer)) {
        layer = [layer];
      }
      this.currentLayer = layer;
      return this;
    };

    QedaPattern.prototype.line = function(x1, y1, x2, y2) {
      this._addShape('line', {
        x1: x1,
        y1: y1,
        x2: x2,
        y2: y2
      });
      return this;
    };

    QedaPattern.prototype.lineTo = function(x, y) {
      this.line(this.x, this.y, x, y);
      return this.moveTo(x, y);
    };

    QedaPattern.prototype.lineWidth = function(lineWidth) {
      this._setLineWidth(lineWidth);
      return this;
    };

    QedaPattern.prototype.moveTo = function(x, y) {
      this.x = x;
      this.y = y;
      return this;
    };

    QedaPattern.prototype.pad = function(name, pad) {
      pad.name = name;
      this.pads[name] = this._addPad(pad);
      return this;
    };

    QedaPattern.prototype.rectangle = function(x1, y1, x2, y2) {
      this.save();
      this.moveTo(x1, y1);
      this.lineTo(x2, y1);
      this.lineTo(x2, y2);
      this.lineTo(x1, y2);
      this.lineTo(x1, y1);
      return this.restore();
    };

    QedaPattern.prototype.rectangleTo = function(x, y) {
      this.rectangle(this.x, this.y, x, y);
      return this.moveTo(x, y);
    };

    QedaPattern.prototype.restore = function() {
      var ref;
      if (this._origin == null) {
        return;
      }
      ref = this._origin.pop(), this.x = ref[0], this.y = ref[1];
      return this;
    };

    QedaPattern.prototype.save = function() {
      if (this._origin == null) {
        this._origin = [];
      }
      this._origin.push([this.x, this.y]);
      return this;
    };

    QedaPattern.prototype._addPad = function(pad) {
      if (pad.type !== 'smd') {
        this.type = 'through-hole';
      }
      return this._addShape('pad', pad);
    };

    QedaPattern.prototype._addShape = function(kind, shape) {
      var obj, prop;
      obj = {
        kind: kind
      };
      for (prop in shape) {
        if (!hasProp.call(shape, prop)) continue;
        obj[prop] = shape[prop];
      }
      if (obj.layer == null) {
        obj.layer = this.currentLayer;
      }
      if (obj.lineWidth == null) {
        obj.lineWidth = this.currentLineWidth;
      }
      this.shapes.push(obj);
      return obj;
    };

    QedaPattern.prototype._mergeObjects = function(dest, src) {
      var k, results, v;
      results = [];
      for (k in src) {
        v = src[k];
        if (typeof v === 'object' && dest.hasOwnProperty(k)) {
          results.push(this.mergeObjects(dest[k], v));
        } else {
          results.push(dest[k] = v);
        }
      }
      return results;
    };

    QedaPattern.prototype._setLineWidth = function(lineWidth) {
      return this.currentLineWidth = lineWidth;
    };

    return QedaPattern;

  })();

  module.exports = QedaPattern;

}).call(this);
