// Generated by CoffeeScript 1.10.0
(function() {
  var designators, purposes, updateElement;

  designators = {
    DA: ['analog'],
    DD: ['digital']
  };

  purposes = {
    RTX: ['isolator', 'interface', 'transceiver'],
    PLM: ['CPLD']
  };

  updateElement = function(element) {
    var classes, designator, keywords, porposeWeight, purpose, refWeight, results, weight;
    if (element.keywords == null) {
      return;
    }
    keywords = element.keywords.replace(/\s+/g, '').split(',');
    refWeight = 0;
    for (designator in designators) {
      classes = designators[designator];
      weight = keywords.filter((function(_this) {
        return function(a) {
          return classes.indexOf(a) !== -1;
        };
      })(this)).length;
      if (weight > refWeight) {
        refWeight = weight;
        element.refDes = designator;
      }
    }
    porposeWeight = 0;
    results = [];
    for (purpose in purposes) {
      classes = purposes[purpose];
      weight = keywords.filter((function(_this) {
        return function(a) {
          return classes.indexOf(a) !== -1;
        };
      })(this)).length;
      if (weight > porposeWeight) {
        porposeWeight = weight;
        results.push(element.purpose = purpose);
      } else {
        results.push(void 0);
      }
    }
    return results;
  };

  module.exports = function(symbol, element) {
    var height, i, j, k, l, left, leftLines, leftPins, len, len1, len2, len3, len4, len5, line, m, n, o, pin, pinLength, pins, ref, results, right, rightLines, rightPins, schematic, settings, space, step, textWidth, w, width, x, x1, x2, y;
    element.refDes = 'D';
    element.purpose = '';
    updateElement(element);
    schematic = element.schematic;
    settings = symbol.settings;
    if (schematic.showPinNames == null) {
      schematic.showPinNames = true;
    }
    if (schematic.showPinNumbers == null) {
      schematic.showPinNumbers = true;
    }
    step = 5;
    pinLength = (ref = settings.pinLenght) != null ? ref : 10;
    left = symbol.left;
    if (symbol.top.length) {
      left.push('-');
      left = left.concat(symbol.top);
    }
    right = symbol.right;
    if (symbol.bottom.length) {
      right.push('-');
      right = right.concat(symbol.bottom);
    }
    pins = element.pins;
    space = settings.space.pin;
    symbol.attribute('refDes', {
      x: 0,
      y: -1,
      halign: 'center',
      valign: 'bottom'
    }).attribute('name', {
      x: 0,
      y: -settings.fontSize.refDes - 2,
      halign: 'center',
      valign: 'bottom',
      visible: false
    }).attribute('user', {
      x: 0,
      y: 3,
      halign: 'center',
      valign: 'top',
      text: element.purpose
    });
    textWidth = element.purpose.length * settings.fontSize.name;
    width = textWidth;
    height = step * (Math.max(left.length, right.length) + 1);
    x = -width / 2;
    leftPins = [];
    leftLines = [];
    y = height / 2 - step * left.length / 2 + step / 2;
    for (j = 0, len = left.length; j < len; j++) {
      i = left[j];
      if (i === '-') {
        leftLines.push({
          y1: y,
          y2: y
        });
        y += step;
        continue;
      }
      pin = pins[i];
      if (pin == null) {
        continue;
      }
      pin.y = y;
      pin.length = pinLength;
      pin.orientation = 'right';
      leftPins.push(pin);
      w = pin.name.length * settings.fontSize.pin + space;
      x1 = -width / 2 - w - space;
      if (x > x1) {
        x = x1;
      }
      y += step;
    }
    width = Math.max(width, -2 * x);
    x = width / 2;
    rightPins = [];
    rightLines = [];
    y = height / 2 - step * right.length / 2 + step / 2;
    for (k = 0, len1 = right.length; k < len1; k++) {
      i = right[k];
      if (i === '-') {
        rightLines.push({
          y1: y,
          y2: y
        });
        y += step;
        continue;
      }
      pin = pins[i];
      if (pin == null) {
        continue;
      }
      pin.y = y;
      pin.length = pinLength;
      pin.orientation = 'left';
      rightPins.push(pin);
      w = pin.name.length * settings.fontSize.pin + space;
      x2 = textWidth / 2 + w + space;
      if (x < x2) {
        x = x2;
      }
      y += step;
    }
    width = Math.max(width, 2 * x);
    width = Math.ceil(width / (2 * settings.gridSize)) * 2 * settings.gridSize;
    symbol.lineWidth(settings.lineWidth.thick).rectangle(-width / 2, 0, width / 2, height, 'foreground').line(-textWidth / 2 - space, 0, -textWidth / 2 - space, height).line(textWidth / 2 + space, 0, textWidth / 2 + space, height);
    for (l = 0, len2 = leftLines.length; l < len2; l++) {
      line = leftLines[l];
      symbol.line(-width / 2, line.y1, -textWidth / 2 - space, line.y2);
    }
    for (m = 0, len3 = rightLines.length; m < len3; m++) {
      line = rightLines[m];
      symbol.line(width / 2, line.y1, textWidth / 2 + space, line.y2);
    }
    for (n = 0, len4 = leftPins.length; n < len4; n++) {
      pin = leftPins[n];
      pin.x = -width / 2 - pinLength;
      symbol.pin(pin);
    }
    results = [];
    for (o = 0, len5 = rightPins.length; o < len5; o++) {
      pin = rightPins[o];
      pin.x = width / 2 + pinLength;
      results.push(symbol.pin(pin));
    }
    return results;
  };

}).call(this);
